extends Control

const CHARACTER = preload("res://Code/Character.tscn")
var time = 0
var rndscene = false

func _ready():
	g.scene = self
	$Prologue/GameName.text = 'Aesthetic Life [v'+str(g.VERSION)
	if !g.SIMPLE_VER: $Prologue/GameName.text += ' EXTENDED] by nonhumans (Dianus)'
	else: $Prologue/GameName.text += ' BASIC] by nonhumans (Dianus)'
	Cash(0)
	Mood('satiety',0)
	Mood('energy',0)
	Mood('fun',0)
	Mood('hygiene',0)
	var _initka = feeling()
	if g.cheat: $UI/Cheats.visible = true
	if g.SIMPLE_VER:
		$UI/Men/Scroll/Grid/Item2.text = 'Boss [EXT]'
		$UI/Men/Scroll/Grid/Item3.text = 'Nudist [EXT]'
		$UI/Men/Scroll/Grid/Item4.text = 'Afro Nudist [EXT]'
		$UI/Men/Scroll/Grid/Item6.text = 'Giant [EXT]'
		$UI/Men/Scroll/Grid/Item7.text = 'Obstetrician [EXT]'
		$UI/Men/Scroll/Grid/Item8.text = 'Girl Nudist [EXT]'
	if !g.survival:
		Cash(INF)
		$UI/satiety.visible = false
		$UI/energy.visible = false
		$UI/fun.visible = false
		$UI/hygiene.visible = false
		$UI/arousal.visible = false
	if g.ingame:
		$Prologue.visible = false
		$UI.visible = true
		g.can_drag = true
		if g.showprologue:
			g.showprologue = false
			newday()
	else:
		$Music.stream = load("res://Sound/calm.mp3")
		$Music.play()
		$Game/Floor.visible = true
	if g.location == 'home':
		if g.ingame:
			$Music.stream = load("res://Sound/cozy_home.mp3")
			$Music.play()
		$UI/Name.text = g.v.name
		$UI/Name.visible = true
		$UI/Build.visible = true
		$Game/Background.modulate = g.v.wall_color
		$Game/Floor.modulate = g.v.floor_color
		$Game/Floor.visible = true
		for o in g.v.objs: CreateObj(o.type,o.position,o.color,o.flip,0.25)
		ClothingUPD()
	elif g.location == 'street':
		$Music.stream = load("res://Sound/calm.mp3")
		$Music.play()
		$Game/Background.texture = load('res://Images/'+g.location+'.jpg')
		for i in range(g.rnd(1,2)): CreateNPC('guy',Vector2(g.rnd(400,900),g.rnd(330,620)))
		for i in range(g.rnd(1,2)): CreateNPC('laborer',Vector2(g.rnd(400,900),g.rnd(330,620)))
		CreateObj('to home',Vector2(92,285),Color.WHITE,false,0.5)
		CreateObj('to bus',Vector2(1153,300),Color.WHITE,false,0.7)
	elif g.location == 'bus':
		$Music.stream = load("res://Sound/fright.mp3")
		$Music.play()
		$Game/Background.texture = load('res://Images/'+g.location+'.jpg')
		for i in range(g.rnd(14,18)): CreateNPC('guy',Vector2(g.rnd(40,1200),g.rnd(330,620)))
		for i in range(g.rnd(6,8)): CreateNPC('laborer',Vector2(g.rnd(40,1200),g.rnd(330,620)))
		CreateObj('locations',Vector2(1100,231),Color.WHITE,false,0.65)
	elif g.location == 'office':
		$Music.stream = load("res://Sound/business.mp3")
		$Music.play()
		$Game/Background.texture = load('res://Images/'+g.location+'.jpg')
		CreateObj('work',Vector2(1133,361),Color.WHITE,false,0.7)
		CreateNPC('boss',Vector2(g.rnd(40,900),g.rnd(330,620)))
	elif g.location == 'beach':
		$Music.stream = load("res://Sound/bliss.mp3")
		$Music.play()
		$Game/Background.texture = load('res://Images/'+g.location+'.jpg')
		CreateObj('swim',Vector2(591,310),Color.WHITE,false,0.5)
		CreateObj('to bus2',Vector2(1184,510),Color.WHITE,false,0.5)
		for i in range(3): CreateNPC('nudist',Vector2(g.rnd(40,900),g.rnd(330,620)))
		for i in range(g.rnd(5,7)): CreateNPC('afro nudist',Vector2(g.rnd(40,900),g.rnd(330,620)))
	elif g.location == 'cafe':
		$Music.stream = load("res://Sound/bliss.mp3")
		$Music.play()
		$Game/Background.texture = load('res://Images/'+g.location+'.jpg')
		CreateNPC('giant',Vector2(g.rnd(40,1200),g.rnd(330,620)))
		CreateObj('from cafe',Vector2(609,215),Color.WHITE,false,0.7)
	elif g.location == 'nightclub':
		$Music.stream = load("res://Sound/clubnyak.mp3")
		$Music.play()
		$Game/Background.texture = load('res://Images/'+g.location+'.jpg')
		for i in range(g.rnd(9,12)): CreateNPC('black man',Vector2(g.rnd(40,1200),g.rnd(330,620)))
		CreateObj('dance',Vector2(200,440),Color.WHITE,false,0.5)
		CreateObj('to bus2',Vector2(1184,510),Color.WHITE,false,0.5)
	elif g.location == 'pool':
		$Music.stream = load("res://Sound/bliss.mp3")
		$Music.play()
		$Game/Background.texture = load('res://Images/'+g.location+'.jpg')
		for i in range(g.rnd(9,11)): CreateNPC('girl swimmer',Vector2(g.rnd(40,1200),g.rnd(330,620)))
		for i in range(g.rnd(1,2)): CreateNPC('afro nudist',Vector2(g.rnd(40,1200),g.rnd(330,620)))
		for i in range(g.rnd(1,2)): CreateNPC('nudist',Vector2(g.rnd(40,1200),g.rnd(330,620)))
		CreateObj('to bus2',Vector2(1184,510),Color.WHITE,false,0.5)
		CreateObj('next',Vector2(90,510),Color.WHITE,true,0.5)
		CreateObj('swim2',Vector2(591,210),Color(1,1,1,0.47),false,0.5)
	elif g.location == 'locker room':
		$Music.stream = load("res://Sound/bliss.mp3")
		$Music.play()
		$Game/Background.texture = load('res://Images/'+g.location+'.jpg')
		for i in range(g.rnd(11,13)): CreateNPC('girl nudist',Vector2(g.rnd(40,1200),g.rnd(330,620)))
		CreateObj('to bus2',Vector2(1184,510),Color.WHITE,false,0.5)
	elif g.location == 'hospital':
		$Music.stream = load("res://Sound/bliss.mp3")
		$Music.play()
		$Game/Background.texture = load('res://Images/'+g.location+'.jpg')
		CreateNPC('obstetrician',Vector2(g.rnd(40,1200),g.rnd(330,620)))
		CreateObj('to bus2',Vector2(90,232),Color.WHITE,true,0.5)
	if !g.BUILD: AudioServer.set_bus_volume_db(g._bus, -100)
	if g.mutemusic: $Music.stop()
func _on_button_pressed():
	var btntext = $UI/Button.text.to_lower()
	btntext = btntext.replace(" #",'')
	btntext = btntext.replace("?",'')
	if DirAccess.dir_exists_absolute('res://Images/art/'+btntext): anim(btntext)
	elif btntext == 'locations':
		$Game/Characters.visible = false
		$UI/Locations.visible = true
		$UI/Button.visible = false
		g.can_drag = false
	elif btntext == 'work':
		Cash(5)
		Mood('energy',-2)
		Mood('fun',-5)
		Memory(btntext)
	elif btntext == 'dance':
		Mood('fun',2)
		Memory(btntext)
	elif btntext == 'sleep':
		newday()
		Mood('energy',100)
		Memory(btntext)
	elif btntext == 'swim':
		if g.v.bottom == null and g.v.top == null and g.v.footwear == null and g.v.underwear == null:
			Mood('hygiene',30)
			Mood('fun',15)
			Memory(btntext)
		else: Info(g.v.name+' must be completely naked!','CONDITION')
	elif btntext == 'watch television':
		Mood('fun',30)
		Memory(btntext)
	elif btntext == 'eat':
		$UI/Button.visible = false
		$UI/Food.visible = true
	elif btntext == 'dress up': $UI/Clothes.visible = true
	elif btntext == 'wash':
		if g.v.bottom == null and g.v.top == null and g.v.footwear == null and g.v.underwear == null:
			art('washing')
			Mood('hygiene',100)
			Memory(btntext)
		else: Info(g.v.name+' must be completely naked!','CONDITION')
	elif btntext == "women's locker room": location('locker room')
	else: location(btntext)
func _on_sound_finished():
	if $NSFW.visible:
		g.can_drag = true
		$Moans.stream = null
		$Moans.stop()
		$Music.playing = true
		$NSFW.visible = false
		$NSFW/Dialog.visible = false
		$NSFW/Anim.texture = null
		$UI.visible = true
		for c in $Game/Characters.get_children(): if c.type != 'player': c.move = true
		if $NSFW/Faster.visible:
			if g.location not in ['locker room','pool','hospital']: Mood('hygiene',-25)
			if g.location not in ['hospital']: Mood('energy',-10)
			if g.location not in ['home','cafe','locker room','pool']:
				if g.location == 'hospital':
					if g.v.gestation >= 100:
						$Game/Characters/Player.texture = load("res://Images/player_body.png")
						g.v.gestation = 0
						g.v.children += 1
						var earn = 150
						Cash(earn)
						Memory('a baby was born')
						Msg('+child!  + $'+str(earn))
				else:
					var earn = int(20*(0.6*(g.v.satiety+g.v.energy+g.v.fun+g.v.hygiene)/100))
					Cash(earn)
					Msg('+ $'+str(earn))
			if g.location == 'cafe': Mood('satiety',40)
			elif g.location == 'pool': Mood('hygiene',30)
		if g.location == 'office': location('bus')
func location(val):
	var success = false
	if val == 'office':
		if g.v.bottom != null and g.v.bottom.find('skirt') != -1 and g.v.top == 'blouse': success = true
		else: Info('Dress code! '+g.v.name+' needs some clothes: blouse, skirt','CONDITION')
	elif val == 'nightclub':
		if g.SIMPLE_VER: Info('NEED EXTENDED VERSION!\n\n===== Buy =====\nnonhumans.itch.io/aesthetic\npatreon.com/dianus','ERROR')
		else:
			if g.v.top != null and g.v.top.find('dress') != -1: success = true
			else: Info('Dress code! '+g.v.name+' needs some clothes: dress','CONDITION')
	elif val == "locker room":
		if g.SIMPLE_VER: Info('NEED EXTENDED VERSION!\n\n===== Buy =====\nnonhumans.itch.io/aesthetic\npatreon.com/dianus','ERROR')
		else: success = true
	else: success = true
	if success:
		if g.v.gestation > 0: g.v.gestation = min(g.v.gestation+g.rnd(6,12),100)
		Mood('energy',-g.rnd(2,4))
		Mood('satiety',-g.rnd(4,6))
		Mood('fun',-g.rnd(2,5))
		if g.location == 'home': g.save_home()
		if val == 'home' and g.location == 'bus': g.location = 'street'
		else: g.location = val
		get_tree().reload_current_scene()
	
	
	
	
	
func anim(animscene):
	$NSFW/Uterus.visible = false
	$NSFW/Uterus.texture = null
	$NSFW/Anim.texture = AnimatedTexture.new()
	$NSFW/Anim.texture.frames = 30
	$NSFW/Anim.texture.speed_scale = 30
	$NSFW/Dialog.visible = false
	if animscene == 'defeated1':
		Memory("fucked by landlord")
		sex_play()
		$NSFW/Dialog.text = 'I definitely need to make money...'
		$NSFW/Dialog.visible = true
	elif animscene == 'can i leave early today, please':
		Memory("fucked by boss")
		sex_play()
		$NSFW/Dialog.text = 'I just wanted to go home...'
		$NSFW/Dialog.visible = true
	elif animscene == 'gangbang1':
		if g.SIMPLE_VER:
			Info('NEED EXTENDED VERSION!\n\n===== Buy =====\nnonhumans.itch.io/aesthetic\npatreon.com/dianus','ERROR')
			return
		Memory("gangbang")
		$Moans.stream = load('res://Sound/blowjob_slow.mp3')
		$Moans.play()
		$Sound.stream = load("res://Sound/ass0.mp3")
		$Sound.play()
		$NSFW/Dialog.text = "I know\nlove is real...\nBecause I exist...\nAnd I'm full of it..."
		$NSFW/Dialog.visible = true
	elif animscene == 'double penetration':
		if g.SIMPLE_VER:
			Info('NEED EXTENDED VERSION!\n\n===== Buy =====\nnonhumans.itch.io/aesthetic\npatreon.com/dianus','ERROR')
			return
		Memory("double penetration")
		sex_play()
		$NSFW/Dialog.text = "I want to be happy...\n\nI just want to be happy..."
		$NSFW/Dialog.visible = true
	elif animscene == 'blowjob1':
		Memory("blowjob")
		$Moans.stream = load('res://Sound/blowjob.mp3')
		$Moans.play()
	elif animscene == 'lesbian':
		Memory("lesbian")
		$Moans.stream = load('res://Sound/moans_slow.mp3')
		$Moans.play()
		$NSFW/Dialog.text = "Ah, my tits...\n\nDon't touch please..."
		$NSFW/Dialog.visible = true
	elif animscene == 'can i have a hot dog, please':
		Memory("fucked for a hot dog")
		$NSFW/Anim.texture.speed_scale = 40
		$Moans.stream = load('res://Sound/moans1.mp3')
		$Moans.play()
		$Sound.stream = load("res://Sound/ooz2.mp3")
		$Sound.volume_db = 5
		$Sound.play()
		$NSFW/Dialog.text = "At least I won't be hungry..."
		$NSFW/Dialog.visible = true
	elif animscene == 'blowbang1':
		$NSFW/Anim.texture.speed_scale = 24
		Memory("blowbang")
		$Moans.stream = load('res://Sound/moans_slow.mp3')
		$Moans.play()
		$Sound.stream = load("res://Sound/ooz.mp3")
		$Sound.play()
	elif animscene == 'vaginal examination1':
		$NSFW/Anim.texture.speed_scale = 24
		Memory("vaginal examination")
		$Moans.stream = load('res://Sound/moans_slow.mp3')
		$Moans.play()
		$Sound.stream = load("res://Sound/ooz2.mp3")
		$Sound.play()
		$NSFW/Dialog.text = "Spread your legs wider.. wider...\n\nThis is a normal procedure, don't worry."
		$NSFW/Dialog.visible = true
	elif animscene == 'vaginal examination2':
		$NSFW/Anim.texture.speed_scale = 30
		Memory("vaginal examination")
		sex_play()
		$NSFW/Dialog.text = "It's okay...\nI'm just expanding your pussy...\n\nI can't wait to meet your little one..."
		$NSFW/Dialog.visible = true
	for c in $Game/Characters.get_children(): c.move = false
	$Music.playing = false
	$UI.visible = false
	$NSFW.visible = true
	$NSFW/Faster.visible = true
	$NSFW/Faster.disabled = false
	$NSFW/Finish.visible = true
	$NSFW/Faster.text = 'Faster!'
	g.can_drag = false
	for i in range(31):
		var id = "%02d"%[i]
		$NSFW/Anim.texture.set_frame_texture(i,load("res://Images/art/"+animscene+'/'+animscene+id+'.png'))
func _process(dt):
	time += dt
	$UI/Msg.position.y -= 60.0*dt
	$UI/Msg.position.x += (cos(time*4.0)*20.0)*dt
	$UI/Msg.modulate.a =max(pow(($UI/Msg.position.y - 200) / 200, 0.35), 0)
	if g.last_node != null:
		$UI/Select.position = g.last_node.position
		$UI/Select.position.x -= 10
	else:
		$UI/Select.position = Vector2(-500,-500)
		#$UI/Trash.visible = false
	if $UI/Button.visible: $UI/Name.visible = false
	elif g.location == 'home' and !g.building: $UI/Name.visible = true
func _on_finish_pressed():
	if 'speed_scale' in $NSFW/Anim.texture:
		$NSFW/Anim.texture.speed_scale = 0
		if g.location in ['pool','locker room']: _on_sound_finished()
		else:
			if g.location in ['home','cafe','office','beach','bus'] and !rndscene:
				Memory('fertilized')
				if g.rndb(30) and g.v.gestation == 0 and g.arousal > 20:
					Memory('got pregnant')
					g.v.gestation = 1
				$NSFW/AnimationPlayer.play("uterus")
				$NSFW/Uterus.visible = true
				$NSFW/Uterus.texture = AnimatedTexture.new()
				$NSFW/Uterus.texture.frames = 30
				$NSFW/Uterus.texture.speed_scale = 30
				for i in range(31):
					var id = "%02d"%[i]
					$NSFW/Uterus.texture.set_frame_texture(i,load('res://Images/art/uretus/uretus'+id+'.png'))
			$Sound.stream = load("res://Sound/cum.mp3")
			$Sound.volume_db = -5
			$Sound.play()
			rndscene = false
		$Sex.stream = null
		$Sex.stop()
		$NSFW/Faster.disabled = true
		$NSFW/Finish.visible = false
	else:
		$Sound.stream = null
		$Sound.stop()
		$NSFW.visible = false
		$UI.visible = true
		$NSFW/Anim.texture = null
		$NSFW/Dialog.visible = false
func CreateObj(type,pos,clr,flp,scl):
	var node = Sprite2D.new()
	node.set_script(load("res://Code/Obj.gd"))
	node.type = type
	node.texture = load('res://Images/'+type+'.png')
	node.position = pos
	node.modulate = clr
	node.flip_h = flp
	node.scale *= scl
	node.default_scale = node.scale.x
	$Game/Objs.add_child(node)
func CreateNPC(type,pos):
	var npc = CHARACTER.instantiate()
	npc.type = type
	npc.obj = false
	npc.position = pos
	$Game/Characters.add_child(npc)
func Msg(val):
	$UI/Msg.text = val
	#$UI/Msg.position.x = $Game/Characters/Player.position.x-170
	#$UI/Msg.position.y = $Game/Characters/Player.position.y-150
	$UI/Msg.position.x = -40
	$UI/Msg.position.y = 500
func moneyformat(val):
	for idx in range(val.length(),0,-3):
		val = val.insert(idx, " ")
	return(val)
func art(artname):
	$UI.visible = false
	$NSFW/Finish.visible = true
	$NSFW.visible = true
	$NSFW/Faster.visible = false
	$NSFW/Anim.texture = null
	$NSFW/Anim.texture = load("res://Images/art/"+artname+'.png')
	if artname == 'washing':
		$Sound.stream = load("res://Sound/shower.mp3")
		$Sound.play()
func _on_faster_pressed():
	if $NSFW/Faster.text == 'Slower!':
		$NSFW/Anim.texture.speed_scale -= 50
		$NSFW/Faster.text = 'Faster!'
		$Sex.pitch_scale = 1.0
	else:
		$Sex.pitch_scale = 1.8
		$NSFW/Anim.texture.speed_scale += 50
		$NSFW/Faster.text = 'Slower!'
func _on_build_mouse_entered():
	$UI/Build.modulate.a = 0.7
func _on_build_mouse_exited():
	$UI/Build.modulate.a = 1
func _on_build_gui_input(e):
	if e is InputEventMouseButton and e.pressed and e.button_index == 1:
		g.building = !g.building
		$UI/Name.visible = !$UI/Name.visible
		$UI/Button.visible = false
		$UI/Color.visible = !$UI/Color.visible
		$UI/Buy.visible = !$UI/Buy.visible
		$UI/Wall.visible = !$UI/Wall.visible
		$UI/Psyche.visible = !$UI/Psyche.visible
		#$UI/CheatMenu.visible = !$UI/CheatMenu.visible
		$UI/Floor.visible = !$UI/Floor.visible
		$UI/Flip.visible = !$UI/Flip.visible
		$UI/Invite.visible = !$UI/Invite.visible
		$UI/Clothing.visible = !$UI/Clothing.visible
		if g.building:
			$UI/Build.texture = load('res://Images/back.png')
			$Game/Characters.visible = false
			$UI/Build.position = Vector2(1197,6)
		else:
			$UI/Build.texture = load('res://Images/build.png')
			g.last_node = null
			get_node('UI/Trash').visible = false
			$Game/Characters.visible = true
			$UI/Build.position = Vector2(957,6)
func _on_color_mouse_entered():
	$UI/Color.modulate.a = 0.7
func _on_color_mouse_exited():
	$UI/Color.modulate.a = 1
func _on_color_gui_input(e):
	if e is InputEventMouseButton and e.pressed and e.button_index == 1 and g.last_node != null:
		g.coloring = !g.coloring
		$UI/ColorPicker.visible = !$UI/ColorPicker.visible
		$UI/ColorPicker/Obj.text = g.last_node.type
		$UI/Build.visible = !$UI/Build.visible
		$UI/Wall.visible = !$UI/Wall.visible
		$UI/Floor.visible = !$UI/Floor.visible
		$UI/Flip.visible = !$UI/Flip.visible
		$UI/Buy.visible = !$UI/Buy.visible
		if g.coloring:
			g.can_drag = false
			$UI/ColorPicker.color = g.last_node.modulate
			$UI/ColorPicker.position.x = g.last_node.position.x+g.last_node.texture.get_size().x/2
			if $UI/ColorPicker.position.x > 900: $UI/ColorPicker.position.x = 100
			$UI/Color.texture = load('res://Images/back.png')
			$UI/Color.position = Vector2(1197,6)
		else:
			$UI/ColorPicker/Obj.text = ''
			g.can_drag = true
			$UI/ColorPicker.color = Color.WHITE
			$UI/Color.texture = load('res://Images/color.png')
			$UI/Color.position = Vector2(1116,6)
func _on_color_picker_color_changed(color):
	g.last_node.modulate = color
func _on_quit_confirmed():
	get_tree().quit()
func Exit():
	if g.ingame:
		if g.location == 'home': g.save_home()
		g.save_game()
		g.scene.get_node("Quit").popup_centered()
		g.scene.get_node("Quit").visible = true
		g.can_drag = false
	else: get_tree().quit()
func _on_wall_gui_input(e):
	if e is InputEventMouseButton and e.pressed and e.button_index == 1:
		$UI/ColorPicker.visible = !$UI/ColorPicker.visible
		$UI/ColorPicker.position.x = 100
		$UI/Color.visible = !$UI/Color.visible
		$UI/Build.visible = !$UI/Build.visible
		$UI/Floor.visible = !$UI/Floor.visible
		$UI/Flip.visible = !$UI/Flip.visible
		$UI/Buy.visible = !$UI/Buy.visible
		g.coloring = !g.coloring
		if g.coloring:
			g.can_drag = false
			$UI/ColorPicker/Obj.text = ''
			g.last_node = $Game/Background
			$UI/ColorPicker.color = g.last_node.modulate
			$UI/Wall.texture = load('res://Images/back.png')
			$UI/Wall.position = Vector2(1197,6)
		else:
			g.can_drag = true
			g.last_node = null
			$UI/Wall.texture = load('res://Images/wall_icon.png')
			$UI/Wall.position = Vector2(1036,6)
func _on_wall_mouse_entered():
	$UI/Wall.modulate.a = 0.7
func _on_wall_mouse_exited():
	$UI/Wall.modulate.a = 1
func _on_floor_gui_input(e):
	if e is InputEventMouseButton and e.pressed and e.button_index == 1:
		$UI/ColorPicker.visible = !$UI/ColorPicker.visible
		$UI/ColorPicker.position.x = 100
		$UI/Color.visible = !$UI/Color.visible
		$UI/Build.visible = !$UI/Build.visible
		$UI/Wall.visible = !$UI/Wall.visible
		$UI/Flip.visible = !$UI/Flip.visible
		$UI/Buy.visible = !$UI/Buy.visible
		$UI/ColorPicker/Obj.text = ''
		g.coloring = !g.coloring
		if g.coloring:
			g.can_drag = false
			g.last_node = $Game/Floor
			$UI/ColorPicker.color = g.last_node.modulate
			$UI/Floor.texture = load('res://Images/back.png')
			$UI/Floor.position = Vector2(1197,6)
		else:
			g.can_drag = true
			g.last_node = null
			$UI/Floor.texture = load('res://Images/floor_icon.png')
			$UI/Floor.position = Vector2(956,6)
func _on_floor_mouse_entered():
	$UI/Floor.modulate.a = 0.7
func _on_floor_mouse_exited():
	$UI/Floor.modulate.a = 1
func _on_buy_gui_input(e):
	if e is InputEventMouseButton and e.pressed and e.button_index == 1:
		$UI/Furniture.visible = !$UI/Furniture.visible
		$UI/Color.visible = !$UI/Color.visible
		$UI/Build.visible = !$UI/Build.visible
		$UI/Wall.visible = !$UI/Wall.visible
		$UI/Floor.visible = !$UI/Floor.visible
		$UI/Flip.visible = !$UI/Flip.visible
		if $UI/Furniture.visible:
			g.can_drag = false
			$UI/Buy.texture = load('res://Images/back.png')
			$UI/Buy.position = Vector2(1197,6)
		else:
			g.can_drag = true
			$UI/Buy.texture = load('res://Images/buy.png')
			$UI/Buy.position = Vector2(876,6)
func _on_buy_mouse_entered():
	$UI/Buy.modulate.a = 0.7
func _on_buy_mouse_exited():
	$UI/Buy.modulate.a = 1
func _on_flip_gui_input(e):
	if e is InputEventMouseButton and e.pressed and e.button_index == 1 and g.last_node != null:
		g.last_node.flip_h = !g.last_node.flip_h
func _on_flip_mouse_entered():
	$UI/Flip.modulate.a = 0.7
func _on_flip_mouse_exited():
	$UI/Flip.modulate.a = 1
func _on_item_pressed(itemid):
	if $UI/CheatMenu.visible:
		var item = $UI/CheatMenu/Grid.get_child(itemid)
		if item.text == 'close cheat menu': $UI/CheatMenu.visible = false
		elif item.text == '+ money': Cash(g.rnd(500,1000))
		elif item.text == '+ stats':
			Mood('satiety',100)
			Mood('energy',100)
			Mood('fun',100)
			Mood('hygiene',100)
		elif item.text == '+ gestation':
			g.v.gestation = 100
			$Game/Characters/Player.texture = load("res://Images/player_body_preg.png")
		elif item.text == 'teleport':
			$Game/Characters.visible = false
			$UI/Locations.visible = true
			$UI/Button.visible = false
			g.can_drag = false
			$UI/CheatMenu.visible = false
		elif item.text == 'mute music':
			g.mutemusic = true
			$Music.stop()
		elif item.text == 'dress up':
			$UI/Clothes.visible = true
			$UI/CheatMenu.visible = false
		elif item.text == 'random H-scene':
			rndscene = true
			anim(g.rnda(g.hscenes))
		elif item.text == 'stop AI':
			for c in $Game/Characters.get_children():
				if c.type != 'player': c.move = false
		elif item.text == 'start AI':
			for c in $Game/Characters.get_children():
				if c.type != 'player': c.move = true
					
	elif $UI/Furniture.visible:
		var item = $UI/Furniture/Tabs/Basic/Scroll/Grid.get_child(itemid)
		var cost = int(item.text.split('\n')[1])
		if g.v.cash >= cost:
			Cash(-cost)
			CreateObj(item.text.split('\n')[0].to_lower(),Vector2(g.rnd(150,700),g.rnd(500,650)),Color.WHITE,false,0.25)
		else: Info('Not enough money!','ERROR')
	else:
		var item = $UI/Men/Scroll/Grid.get_child(itemid)
		var success = false
		if '[EXT]' in item.text: Info('NEED EXTENDED VERSION!\n\n===== Buy =====\nnonhumans.itch.io/aesthetic\npatreon.com/dianus','ERROR')
		else: success = true
		if success: CreateNPC(item.text.to_lower(),Vector2(g.rnd(100,800),g.rnd(400,550)))
func dress(type,clothing):
	get_node('Game/Characters/Player/'+type).texture = load('res://Images/player_'+clothing+'.png')
	g.v[type.to_lower()] = clothing
func _on_dress_pressed(tab,itemid):
	var item = get_node('UI/Clothes/Tabs/'+tab+'/Scroll/Grid').get_child(itemid)
	var cost = int(item.text.split('\n')[1])
	if g.v.cash >= cost:
		if cost > 0 and item.text.split('\n')[0].to_lower() not in g.v.myclothing:
			g.v.myclothing.push_back(item.text.split('\n')[0].to_lower())
			ClothingUPD()
		Cash(-cost)
		dress(tab,item.text.split('\n')[0].to_lower())
	else: Info('Not enough money!','ERROR')
func _on_itemEX_pressed(itemid):
	var item = $UI/Furniture/Tabs/Extra/Scroll/Grid.get_child(itemid)
	var cost = int(item.text.split('\n')[1])
	if g.SIMPLE_VER:
		Info('NEED EXTENDED VERSION!\n\n===== Buy =====\nnonhumans.itch.io/aesthetic\npatreon.com/dianus','ERROR')
		return
	if g.v.cash >= cost:
		Cash(-cost)
		CreateObj(item.text.split('\n')[0].to_lower(),Vector2(g.rnd(150,700),g.rnd(500,650)),Color.WHITE,false,0.25)
	else: Info('Not enough money!','ERROR')
func _on_itemDECOR_pressed(itemid):
	var item = $UI/Furniture/Tabs/Decor/Scroll/Grid.get_child(itemid)
	var cost = int(item.text.split('\n')[1])
	if g.v.cash >= cost:
		Cash(-cost)
		CreateObj(item.text.split('\n')[0].to_lower(),Vector2(g.rnd(150,700),g.rnd(500,650)),Color.WHITE,false,0.25)
	else: Info('Not enough money!','ERROR')
func _on_invite_gui_input(e):
	if e is InputEventMouseButton and e.pressed and e.button_index == 1:
		$UI/Men.visible = !$UI/Men.visible
		if $UI/Men.visible:
			g.can_drag = false
			$UI/Invite.texture = load('res://Images/back.png')
		else:
			g.can_drag = true
			$UI/Invite.texture = load('res://Images/invite.png')
func _on_invite_mouse_entered():
	$UI/Invite.modulate.a = 0.7
func _on_invite_mouse_exited():
	$UI/Invite.modulate.a = 1
func Cash(val):
	if g.survival: g.v.cash = max(g.v.cash+val,0)
	else: g.v.cash = 9999999
	$UI/Cash.text = '$'+str(g.v.cash)
func Mood(type,val):
	if g.survival:
		var clr
		val = round(val-(g.v.debuff/200.0)*abs(val))
		g.v[type] = g.clamp2(g.v[type]+val)
		if g.v[type] >= 60:
			clr = Color('27a56c')
			if type == 'hygiene': $Game/Characters/Player/Hygiene.texture = null
			elif type == 'energy': $Night.modulate.a = 0
		elif g.v[type] >= 30:
			clr = Color('a59627')
			if type == 'hygiene': $Game/Characters/Player/Hygiene.texture = load('res://Images/hygiene1.png')
			elif type == 'energy': $Night.modulate.a = 0.3
		else:
			clr = Color('a52727')
			if type == 'hygiene': $Game/Characters/Player/Hygiene.texture = load('res://Images/hygiene2.png')
			elif type == 'energy': $Night.modulate.a = 0.7
		get_node('UI/'+type).get_theme_stylebox("disabled").bg_color = clr
		g.arousal = int(20*(0.6*(g.v.satiety+g.v.energy+g.v.fun+g.v.hygiene)/100))
		if g.arousal >= 30:
			$UI/arousal.get_theme_stylebox("disabled").bg_color = Color('27a56c')
			g.v.debuff = max(g.v.debuff-30,0)
		elif g.arousal >= 15: $UI/arousal.get_theme_stylebox("disabled").bg_color = Color('a59627')
		else: $UI/arousal.get_theme_stylebox("disabled").bg_color = Color('a52727')
		if val > 0: Msg('+'+str(val)+' '+type)
		elif val < 0: Msg(str(val)+' '+type)
func _on_clothes_close_pressed():
	g.can_drag = true
	$UI/Clothes.visible = false
	$UI/Psyche2.visible = false
func _on_takeoff_close_pressed():
	$"UI/Take off".visible = false
func _on_takeoff_pressed(itemid):
	var item = $"UI/Take off/Grid".get_child(itemid).text
	$Game/Characters/Player.get_node(item).texture = null
	g.v[item.to_lower()] = null
func _on_clothing_gui_input(e):
	if e is InputEventMouseButton and e.pressed and e.button_index == 1: $"UI/Take off".visible = true
func _on_clothing_mouse_entered():
	$UI/Clothing.modulate.a = 0.7
func _on_clothing_mouse_exited():
	$UI/Clothing.modulate.a = 1
func _on_quit_canceled():
	g.can_drag = true
func _on_food_close_pressed():
	$UI/Food.visible = false
func _on_food_pressed(itemid):
	var item = $UI/Food/Grid.get_child(itemid)
	var cost = int(item.text.split('\n')[1])
	var food = item.text.split('\n')[0].to_lower()
	if g.v.cash >= cost:
		Cash(-cost)
		if itemid == 0: Mood('satiety',6)
		elif itemid == 1: Mood('satiety',12)
		elif itemid == 2: Mood('satiety',25)
		elif itemid == 3: Mood('satiety',50)
		Memory("eat (%s)"%food)
	else: Info('Not enough money!','ERROR')
func ClothingUPD():
	for i in $UI/Clothes/Tabs/Top/Scroll/Grid.get_children(): 
		if i.text.split('\n')[0].to_lower() in g.v.myclothing: i.text = i.text.split('\n')[0]+'\n$0'
	for i in $UI/Clothes/Tabs/Bottom/Scroll/Grid.get_children(): 
		if i.text.split('\n')[0].to_lower() in g.v.myclothing: i.text = i.text.split('\n')[0]+'\n$0'
	for i in $UI/Clothes/Tabs/Underwear/Scroll/Grid.get_children(): 
		if i.text.split('\n')[0].to_lower() in g.v.myclothing: i.text = i.text.split('\n')[0]+'\n$0'
	for i in $UI/Clothes/Tabs/Footwear/Scroll/Grid.get_children(): 
		if i.text.split('\n')[0].to_lower() in g.v.myclothing: i.text = i.text.split('\n')[0]+'\n$0'	
func _on_load_game_pressed():
	if !g.ingame:
		if g.nosave:
			_on_new_game_pressed()
		else:
			g.load_game()
			g.ingame = true
			get_tree().reload_current_scene()
	else:
		$Prologue.visible = false
		$UI.visible = true
		g.can_drag = true
func _on_new_game_pressed():
	g.init_var()
	g.showprologue = true
	g.ingame = true
	g.nosave = true
	get_tree().reload_current_scene()
func Info(val,title):
	g.can_drag = false
	$Info.size = Vector2(0,0)
	$Info.dialog_text = val
	$Info.title = title
	$Info.popup_centered()
	$Info.size = Vector2(0,0)
	$Info.popup_centered()
func _on_info_click():
	g.can_drag = true
	if 'NEW DAY' in $Info.title:
		if g.v.cash < g.RENT: anim('defeated1')
		else: Cash(-g.RENT)
func newday():
	g.v.day += 1
	if g.v.cash >= g.RENT: Info('The landlord took $%s from %s for the apartment rent.'%[g.RENT,g.v.name],'NEW DAY (%s)'%g.v.day)
	else: Info('The landlord came to collect $%s from %s for the apartment rent, but she doesn’t have enough money.\n— You don’t have money for rent?! Well... Come to me...'%[g.RENT,g.v.name],'NEW DAY (%s)'%g.v.day)
func _on_name_mouse_exited():
	$UI/Name.release_focus()
func _on_name_text_changed(new_text):
	g.v.name = new_text
func _on_check_btn_1_toggled(toggled_on):
	g.survival = toggled_on
	$Prologue/Text.text = "My new home!\nBut I'm completely broke...\nI wonder how I'm gonna pay the rent?.."
func _on_check_btn_2_toggled(toggled_on):
	if g.SIMPLE_VER:
		Info('NEED EXTENDED VERSION!\n\n===== Buy =====\nnonhumans.itch.io/aesthetic\npatreon.com/dianus','ERROR')
		$Prologue/Panel/CheckBTN1.button_pressed = true
	else: $Prologue/Text.text = "\nLife is a creative process of events.\nI'm forced to be free."
func _on_exit_pressed():
	Exit()
func sex_play():
	$Moans.stream = load('res://Sound/moans0.mp3')
	$Moans.play()
	$Sex.stream = load('res://Sound/ass0.mp3')
	$Sex.play()
func _on_psyche_gui_input(e):
	if e is InputEventMouseButton and e.pressed and e.button_index == 1:
		g.can_drag = false
		$UI/Psyche2.visible = true
		$UI/Psyche2/TextEdit.text = g.v.memory
		$UI/Psyche2/TextEdit.set_deferred("scroll_vertical",99999999)
		var val = ''
		if g.arousal >= 30: val = 'Normal'
		elif g.arousal >= 15: val = 'Exhausted'
		else: val = 'Depressed'
		$UI/Psyche2/info.text = "Well-being: %s"%val+'\n'
		val = feeling()
		$UI/Psyche2/info.text += "Feeling: %s"%val+'\n'
		if g.v.hygiene >= 60: val = "Perfect"
		elif g.v.hygiene >= 30: val = "Shame"
		else: val = "Terrible"
		$UI/Psyche2/info.text += "Appearance: %s"%val+'\n'
		$UI/Psyche2/info.text += "Stress (debuff): %s%%"%g.v.debuff
		$UI/Psyche2/info2.text = "Gestation: %s%%"%g.v.gestation+'\n'
		$UI/Psyche2/info2.text += "Children: %s"%g.v.children+'\n'
func _on_psyche_mouse_entered():
	$UI/Psyche.modulate.a = 0.7
func _on_psyche_mouse_exited():
	$UI/Psyche.modulate.a = 1
func Memory(val):
	var result = '   [Day %s] '%g.v.day
	if result in g.v.memory: result = ''
	else: result = '\n'+result
	if g.arousal >= 30: g.v.debuff -= 5
	elif g.arousal >= 15: g.v.debuff += 1
	else: g.v.debuff += 3
	g.v.debuff = clamp(g.v.debuff,0,100)
	result += g.feeling+": "
	result += val+' at '+g.location
	g.v.memory += result+'. '
func feeling():
	var val = ''
	if g.v.debuff <= 1: val = 'Satisfied'
	elif g.v.debuff <= 5: val = 'Overwhelm'
	elif g.v.debuff <= 10: val = 'Weakness'
	elif g.v.debuff <= 15: val = 'Sadness'
	elif g.v.debuff <= 20: val = 'Frustration'
	elif g.v.debuff <= 30: val = 'Apathy'
	elif g.v.debuff <= 35: val = 'Melancholy'
	elif g.v.debuff <= 45: val = 'Anxiety'
	elif g.v.debuff <= 55: val = 'Panic attacks'
	elif g.v.debuff <= 60: val = 'Hallucinations'
	elif g.v.debuff <= 65: val = 'Paranoia'
	elif g.v.debuff <= 75: val = 'Dissociation'
	elif g.v.debuff <= 90: val = 'Hopelessness'
	elif g.v.debuff <= 100: val = 'Despair'
	g.feeling = val
	return val
func _on_trash_gui_input(e):
	if e is InputEventMouseButton and e.pressed and e.button_index == 1:
		g.last_node.queue_free()
		g.last_node = null
		#if !obj: $Shadow.visible = true
		g.drag = false
		Input.set_custom_mouse_cursor(g.cdefault)
		get_node('UI/Button').visible = false
		get_node('UI/HelpRemove').visible = false
		get_node('UI/Trash').visible = false
func _on_cheats_gui_input(e):
	if e is InputEventMouseButton and e.pressed and e.button_index == 1:
		$UI/CheatMenu.visible = true
		
